<script lang="ts" setup>
import { ref } from 'vue';
import { ChevronLgRight, ChevronLgLeft } from 'slippers-ui/icons';
interface SearchPaginationProps {
  totalPages: number;
  perPage: number;
  currentPage: number;
  pageContent: pageContentProps;
}
interface pageContentProps {
  pagination: {
    prevButton: string;
    nextButton: string;
    page: string;
  };
}
//Props
const props = defineProps<SearchPaginationProps>();

//Emits
const emit = defineEmits(['pageChange']);

// Reactive data
const maxVisibleButtons = ref(5);

// Computed data
const startPage = computed(() => {
  if (props.currentPage === 1) {
    return 1;
  }

  if (props.currentPage === props.totalPages) {
    return props.totalPages <= maxVisibleButtons.value ? 1 : props.totalPages + 1 - maxVisibleButtons.value;
  }

  if (props.currentPage - 2 <= 0) {
    return props.currentPage - 1;
  }

  return props.currentPage - 2;
});
const pages = computed(() => {
  const range = [];
  for (
    let i = startPage.value;
    i <= Math.min(Number(startPage.value) + Number(maxVisibleButtons.value) - 1, Number(props.totalPages));
    i++
  ) {
    range.push({ name: i, isDisabled: i === props.currentPage });
  }
  return range;
});
const isInFirstPage = computed(() => {
  return props.currentPage === 1;
});
const isInLastPage = computed(() => {
  return props.currentPage === props.totalPages;
});

// Methods
const onClickPreviousPage = () => {
  emit('pageChange', props.currentPage - 1);
};

const onClickPage = (page: number) => {
  emit('pageChange', page);
};

const onClickNextPage = () => {
  emit('pageChange', props.currentPage + 1);
};

const isPageActive = (page: number) => {
  return props.currentPage === page;
};
</script>

<template>
  <div class="pagination">
    <ul>
      <li v-if="!isInFirstPage && totalPages !== 0">
        <SlpButton
          variant="secondary"
          :disabled="isInFirstPage"
          :aria-label="`${pageContent?.pagination?.prevButton} ${pageContent?.pagination?.page}`"
          @click="onClickPreviousPage()"
        >
          <SlpIcon class="slp-mr-8" :icon="ChevronLgLeft" />
          {{ pageContent?.pagination?.prevButton }}
        </SlpButton>
      </li>
      <li v-for="page in pages" :key="page.name">
        <SlpButton
          class=""
          variant="secondary"
          :disabled="page.isDisabled"
          :class="{ 'pagination--active': isPageActive(page.name) }"
          :aria-current="isPageActive(page.name) ? 'page' : false"
          :aria-label="`${pageContent?.pagination?.page} ${page.name}`"
          @click="!page.isDisabled && onClickPage(page.name)"
        >
          {{ page.name }}
        </SlpButton>
      </li>
      <li v-if="!isInLastPage && totalPages !== 0">
        <SlpButton
          variant="secondary"
          :disabled="isInLastPage"
          :aria-label="`${pageContent?.pagination?.nextButton} ${pageContent?.pagination?.page}`"
          @click="onClickNextPage()"
        >
          {{ pageContent?.pagination?.nextButton }}
          <SlpIcon class="slp-ml-8" :icon="ChevronLgRight" />
        </SlpButton>
      </li>
    </ul>
  </div>
</template>

<style lang="scss" scoped>
.pagination {
  display: flex;
  justify-content: flex-end;
  padding: $spacing-24;

  &--active {
    background-color: $color-surface-800 !important;
    color: $color-primary-200 !important;
  }

  ul {
    display: flex;

    .slp-btn {
      justify-content: center;
      padding: $spacing-4 12px;
      margin: 0;
      min-width: unset;

      &:not(.slp-btn-disabled) {
        color: $color-surface-700;
      }

      &:hover:not(.slp-btn-disabled) {
        background-color: #e3d6ff;
      }
    }
  }
}
</style>
